Index: branches/RWT/modules/vci_mem_cache/caba/source/src/vci_mem_cache.cpp
===================================================================
--- branches/RWT/modules/vci_mem_cache/caba/source/src/vci_mem_cache.cpp	(revision 477)
+++ branches/RWT/modules/vci_mem_cache/caba/source/src/vci_mem_cache.cpp	(revision 495)
@@ -3894,184 +3934,324 @@
     ////////////////////////
     case IXR_CMD_READ_IDLE:
-      if     (r_write_to_ixr_cmd_req)    r_ixr_cmd_fsm = IXR_CMD_WRITE;
-      else if(r_cas_to_ixr_cmd_req)      r_ixr_cmd_fsm = IXR_CMD_CAS;
-      else if(r_xram_rsp_to_ixr_cmd_req) r_ixr_cmd_fsm = IXR_CMD_XRAM;
-      else if(r_cleanup_to_ixr_cmd_req)  r_ixr_cmd_fsm = IXR_CMD_CLEANUP_DATA;
-      else if(r_read_to_ixr_cmd_req)     r_ixr_cmd_fsm = IXR_CMD_READ;
+      if     (r_write_to_ixr_cmd_req.read())      r_ixr_cmd_fsm = IXR_CMD_WRITE_TRT;
+      else if(r_cas_to_ixr_cmd_req.read())        r_ixr_cmd_fsm = IXR_CMD_CAS_TRT;
+      else if(r_cleanup_to_ixr_cmd_req.read())    r_ixr_cmd_fsm = IXR_CMD_CLEANUP_TRT;
+      else if(r_xram_rsp_to_ixr_cmd_req.read())   r_ixr_cmd_fsm = IXR_CMD_XRAM_TRT;
+      else if(r_config_to_ixr_cmd_req.read())     r_ixr_cmd_fsm = IXR_CMD_CONFIG_TRT;
+      else if(r_read_to_ixr_cmd_req.read())       r_ixr_cmd_fsm = IXR_CMD_READ_TRT;
       break;
     ////////////////////////
     case IXR_CMD_WRITE_IDLE:
-      if(r_cas_to_ixr_cmd_req)           r_ixr_cmd_fsm = IXR_CMD_CAS;
-      else if(r_xram_rsp_to_ixr_cmd_req) r_ixr_cmd_fsm = IXR_CMD_XRAM;
-      else if(r_cleanup_to_ixr_cmd_req)  r_ixr_cmd_fsm = IXR_CMD_CLEANUP_DATA;
-      else if(r_read_to_ixr_cmd_req)     r_ixr_cmd_fsm = IXR_CMD_READ;
-      else if(r_write_to_ixr_cmd_req)    r_ixr_cmd_fsm = IXR_CMD_WRITE;
+      if     (r_cas_to_ixr_cmd_req.read())        r_ixr_cmd_fsm = IXR_CMD_CAS_TRT;
+      else if(r_cleanup_to_ixr_cmd_req.read())    r_ixr_cmd_fsm = IXR_CMD_CLEANUP_TRT;
+      else if(r_xram_rsp_to_ixr_cmd_req.read())   r_ixr_cmd_fsm = IXR_CMD_XRAM_TRT;
+      else if(r_config_to_ixr_cmd_req.read())     r_ixr_cmd_fsm = IXR_CMD_CONFIG_TRT;
+      else if(r_read_to_ixr_cmd_req.read())       r_ixr_cmd_fsm = IXR_CMD_READ_TRT;
+      else if(r_write_to_ixr_cmd_req.read())      r_ixr_cmd_fsm = IXR_CMD_WRITE_TRT;
       break;
     ////////////////////////
     case IXR_CMD_CAS_IDLE:
-      if(r_xram_rsp_to_ixr_cmd_req)      r_ixr_cmd_fsm = IXR_CMD_XRAM;
-      else if(r_cleanup_to_ixr_cmd_req)  r_ixr_cmd_fsm = IXR_CMD_CLEANUP_DATA;
-      else if(r_read_to_ixr_cmd_req)     r_ixr_cmd_fsm = IXR_CMD_READ;
-      else if(r_write_to_ixr_cmd_req)    r_ixr_cmd_fsm = IXR_CMD_WRITE;
-      else if(r_cas_to_ixr_cmd_req)      r_ixr_cmd_fsm = IXR_CMD_CAS;
+      if     (r_cleanup_to_ixr_cmd_req.read())    r_ixr_cmd_fsm = IXR_CMD_CLEANUP_TRT;
+      else if(r_xram_rsp_to_ixr_cmd_req.read())   r_ixr_cmd_fsm = IXR_CMD_XRAM_TRT;
+      else if(r_config_to_ixr_cmd_req.read())     r_ixr_cmd_fsm = IXR_CMD_CONFIG_TRT;
+      else if(r_read_to_ixr_cmd_req.read())       r_ixr_cmd_fsm = IXR_CMD_READ_TRT;
+      else if(r_write_to_ixr_cmd_req.read())      r_ixr_cmd_fsm = IXR_CMD_WRITE_TRT;
+      else if(r_cas_to_ixr_cmd_req.read())        r_ixr_cmd_fsm = IXR_CMD_CAS_TRT;
       break;
     ////////////////////////
     case IXR_CMD_XRAM_IDLE:
-      if(r_cleanup_to_ixr_cmd_req)     r_ixr_cmd_fsm = IXR_CMD_CLEANUP_DATA;
-      else if(r_read_to_ixr_cmd_req)     r_ixr_cmd_fsm = IXR_CMD_READ;
-      else if(r_write_to_ixr_cmd_req)     r_ixr_cmd_fsm = IXR_CMD_WRITE;
-      else if(r_cas_to_ixr_cmd_req)      r_ixr_cmd_fsm = IXR_CMD_CAS;
-      else if(r_xram_rsp_to_ixr_cmd_req) r_ixr_cmd_fsm = IXR_CMD_XRAM;
+      if     (r_config_to_ixr_cmd_req.read())     r_ixr_cmd_fsm = IXR_CMD_CONFIG_TRT;
+      else if(r_read_to_ixr_cmd_req.read())       r_ixr_cmd_fsm = IXR_CMD_READ_TRT;
+      else if(r_write_to_ixr_cmd_req.read())      r_ixr_cmd_fsm = IXR_CMD_WRITE_TRT;
+      else if(r_cas_to_ixr_cmd_req.read())        r_ixr_cmd_fsm = IXR_CMD_CAS_TRT;
+      else if(r_cleanup_to_ixr_cmd_req.read())    r_ixr_cmd_fsm = IXR_CMD_CLEANUP_TRT;
+      else if(r_xram_rsp_to_ixr_cmd_req.read())   r_ixr_cmd_fsm = IXR_CMD_XRAM_TRT;
       break;
       ////////////////////////
     case IXR_CMD_CLEANUP_IDLE:
       /*ODCCP*///std::cout << "IXR_CMD_CLEANUP_IDLE" << std::endl;
-      if(r_read_to_ixr_cmd_req)     r_ixr_cmd_fsm = IXR_CMD_READ;
-      else if(r_write_to_ixr_cmd_req)     r_ixr_cmd_fsm = IXR_CMD_WRITE;
-      else if(r_cas_to_ixr_cmd_req)      r_ixr_cmd_fsm = IXR_CMD_CAS;
-      else if(r_xram_rsp_to_ixr_cmd_req) r_ixr_cmd_fsm = IXR_CMD_XRAM;
-      else if(r_cleanup_to_ixr_cmd_req)     r_ixr_cmd_fsm = IXR_CMD_CLEANUP_DATA;
+      if     (r_read_to_ixr_cmd_req.read())       r_ixr_cmd_fsm = IXR_CMD_READ_TRT;
+      else if(r_write_to_ixr_cmd_req.read())      r_ixr_cmd_fsm = IXR_CMD_WRITE_TRT;
+      else if(r_cas_to_ixr_cmd_req.read())        r_ixr_cmd_fsm = IXR_CMD_CAS_TRT;
+      else if(r_xram_rsp_to_ixr_cmd_req.read())   r_ixr_cmd_fsm = IXR_CMD_XRAM_TRT;
+      else if(r_config_to_ixr_cmd_req.read())     r_ixr_cmd_fsm = IXR_CMD_CONFIG_TRT;
+      else if(r_cleanup_to_ixr_cmd_req)           r_ixr_cmd_fsm = IXR_CMD_CLEANUP_TRT;
       break;      
-    //////////////////       // send a get from READ FSM
-    case IXR_CMD_READ:
-    {
-      if(p_vci_ixr.cmdack)
-      {
-        r_ixr_cmd_fsm = IXR_CMD_READ_IDLE;
-        r_read_to_ixr_cmd_req = false;
+    /////////////////////////
+    case IXR_CMD_CONFIG_IDLE:
+    {
+      if     (r_read_to_ixr_cmd_req.read())       r_ixr_cmd_fsm = IXR_CMD_READ_TRT;
+      else if(r_write_to_ixr_cmd_req.read())      r_ixr_cmd_fsm = IXR_CMD_WRITE_TRT;
+      else if(r_cas_to_ixr_cmd_req.read())        r_ixr_cmd_fsm = IXR_CMD_CAS_TRT;
+      else if(r_cleanup_to_ixr_cmd_req)           r_ixr_cmd_fsm = IXR_CMD_CLEANUP_TRT;
+      else if(r_xram_rsp_to_ixr_cmd_req.read())   r_ixr_cmd_fsm = IXR_CMD_XRAM_TRT;
+      else if(r_config_to_ixr_cmd_req.read())     r_ixr_cmd_fsm = IXR_CMD_CONFIG_TRT;
+      break;
+    }
+ 
+    //////////////////////
+    case IXR_CMD_READ_TRT:       // access TRT for a GET
+    {
+        if ( r_alloc_trt_fsm.read() == ALLOC_TRT_IXR_CMD )
+        {
+            TransactionTabEntry entry = m_trt.read( r_read_to_ixr_cmd_index.read() );
+            r_ixr_cmd_address = entry.nline * (m_words<<2);
+            r_ixr_cmd_trdid   = r_read_to_ixr_cmd_index.read();
+            r_ixr_cmd_get     = true;
+            r_ixr_cmd_word    = 0;
+            r_ixr_cmd_fsm     = IXR_CMD_READ_SEND;
+            for( size_t i=0 ; i<m_words ; i++ ) r_ixr_cmd_wdata[i] = entry.wdata[i];
 
 #if DEBUG_MEMC_IXR_CMD
 if(m_debug)
-std::cout << "  <MEMC " << name() << " IXR_CMD_READ>"
-          << " Send a get request to xram / address = " << std::hex
-          << (addr_t)(r_read_to_ixr_cmd_nline.read()*m_words*4) << std::endl;
-#endif
-      }
-      break;
-    }
-    ///////////////////
-    case IXR_CMD_WRITE:     // send a put or get from WRITE FSM
-    {
-      if(p_vci_ixr.cmdack)
-      {
-        if(r_write_to_ixr_cmd_write.read())   // PUT
-        {
-          if(r_ixr_cmd_cpt.read() == (m_words - 2))
-          {
-            r_ixr_cmd_cpt = 0;
-            r_ixr_cmd_fsm = IXR_CMD_WRITE_IDLE;
-            r_write_to_ixr_cmd_req = false;
-          }
-          else
-          {
-            r_ixr_cmd_cpt = r_ixr_cmd_cpt + 2;
-          }
+std::cout << "  <MEMC " << name() << " IXR_CMD_READ_TRT> TRT access"
+          << " index = " << std::dec << r_read_to_ixr_cmd_index.read()
+          << " / address = " << std::hex << (entry.nline*(m_words<<2)) << std::endl;
+#endif
+        }
+        break;
+    }
+    ///////////////////////
+    case IXR_CMD_WRITE_TRT:       // access TRT for a PUT or a GET
+    {
+        if ( r_alloc_trt_fsm.read() == ALLOC_TRT_IXR_CMD )
+        {
+            TransactionTabEntry entry = m_trt.read( r_write_to_ixr_cmd_index.read() );
+            r_ixr_cmd_address = entry.nline * (m_words<<2);
+            r_ixr_cmd_trdid   = r_write_to_ixr_cmd_index.read();
+            r_ixr_cmd_get     = entry.xram_read;
+            r_ixr_cmd_word    = 0;
+            r_ixr_cmd_fsm     = IXR_CMD_WRITE_SEND;
+            for( size_t i=0 ; i<m_words ; i++ ) r_ixr_cmd_wdata[i] = entry.wdata[i];
 
 #if DEBUG_MEMC_IXR_CMD
 if(m_debug)
-std::cout << "  <MEMC " << name() << " IXR_CMD_WRITE>"
-          << " Send a put request to xram / address = " << std::hex
-          << (addr_t)((r_write_to_ixr_cmd_nline.read() * m_words +
-                      r_ixr_cmd_cpt.read()) * 4 ) << std::endl;
-#endif
-        }
-        else                                  // GET
-        {
-          r_ixr_cmd_fsm = IXR_CMD_WRITE_IDLE;
-          r_write_to_ixr_cmd_req = false;
+std::cout << "  <MEMC " << name() << " IXR_CMD_WRITE_TRT> TRT access"
+          << " index = " << std::dec << r_write_to_ixr_cmd_index.read()
+          << " / address = " << std::hex << (entry.nline*(m_words<<2)) << std::endl;
+#endif
+        }
+        break;
+    }
+    /////////////////////
+    case IXR_CMD_CAS_TRT:       // access TRT for a PUT or a GET 
+    {
+        if ( r_alloc_trt_fsm.read() == ALLOC_TRT_IXR_CMD )
+        {
+            TransactionTabEntry entry = m_trt.read( r_cas_to_ixr_cmd_index.read() );
+            r_ixr_cmd_address = entry.nline * (m_words<<2);
+            r_ixr_cmd_trdid   = r_cas_to_ixr_cmd_index.read();
+            r_ixr_cmd_get     = entry.xram_read;
+            r_ixr_cmd_word    = 0;
+            r_ixr_cmd_fsm     = IXR_CMD_CAS_SEND;
+            for( size_t i=0 ; i<m_words ; i++ ) r_ixr_cmd_wdata[i] = entry.wdata[i];
 
 #if DEBUG_MEMC_IXR_CMD
 if(m_debug)
-std::cout << "  <MEMC " << name() << " IXR_CMD_WRITE>"
-          << " Send a get request to xram / address = " << std::hex
-          << (addr_t)(r_write_to_ixr_cmd_nline.read()*m_words*4) << std::endl;
-#endif
-        }
-      }
-      break;
-    }
-    /////////////////
-    case IXR_CMD_CAS:      // send a put or get command from CAS FSM
-    {
-      if(p_vci_ixr.cmdack)
-      {
-        if(r_cas_to_ixr_cmd_write.read()) // PUT
-        {
-          if(r_ixr_cmd_cpt.read() == (m_words - 2))
-          {
-            r_ixr_cmd_cpt = 0;
-            r_ixr_cmd_fsm = IXR_CMD_CAS_IDLE;
-            r_cas_to_ixr_cmd_req = false;
-          }
-          else
-          {
-            r_ixr_cmd_cpt = r_ixr_cmd_cpt + 2;
-          }
+std::cout << "  <MEMC " << name() << " IXR_CMD_CAS_TRT> TRT access"
+          << " index = " << std::dec << r_cas_to_ixr_cmd_index.read()
+          << " / address = " << std::hex << (entry.nline*(m_words<<2)) << std::endl;
+#endif
+        }
+        break;
+    }
+    //////////////////////
+    case IXR_CMD_XRAM_TRT:       // access TRT for a PUT 
+    {
+        if ( r_alloc_trt_fsm.read() == ALLOC_TRT_IXR_CMD )
+        {
+            TransactionTabEntry entry = m_trt.read( r_xram_rsp_to_ixr_cmd_index.read() );
+            r_ixr_cmd_address = entry.nline * (m_words<<2);
+            r_ixr_cmd_trdid   = r_xram_rsp_to_ixr_cmd_index.read();
+            r_ixr_cmd_get     = false;
+            r_ixr_cmd_word    = 0;
+            r_ixr_cmd_fsm     = IXR_CMD_XRAM_SEND;
+            for( size_t i=0 ; i<m_words ; i++ ) r_ixr_cmd_wdata[i] = entry.wdata[i];
 
 #if DEBUG_MEMC_IXR_CMD
 if(m_debug)
-std::cout << "  <MEMC " << name() << " IXR_CMD_CAS>"
-          << " Send a put request to xram / address = " << std::hex
-          << (addr_t)( (r_cas_to_ixr_cmd_nline.read() * m_words +
-                      r_ixr_cmd_cpt.read()) * 4 ) << std::endl;
-#endif
-        }
-        else                            // GET
-        {
-          r_ixr_cmd_fsm = IXR_CMD_CAS_IDLE;
-          r_cas_to_ixr_cmd_req = false;
+std::cout << "  <MEMC " << name() << " IXR_CMD_XRAM_TRT> TRT access"
+          << " index = " << std::dec << r_xram_rsp_to_ixr_cmd_index.read()
+          << " / address = " << std::hex << (entry.nline*(m_words<<2)) << std::endl;
+#endif
+        }
+        break;
+    }
+    //////////////////////
+    case IXR_CMD_CLEANUP_TRT:       // access TRT for a PUT 
+    {
+        if ( r_alloc_trt_fsm.read() == ALLOC_TRT_IXR_CMD )
+        {
+          
+            TransactionTabEntry entry = m_trt.read( r_cleanup_to_ixr_cmd_index.read() );
+            r_ixr_cmd_address = entry.nline * (m_words<<2);
+            r_ixr_cmd_trdid   = r_cleanup_to_ixr_cmd_index.read();
+            r_ixr_cmd_get     = false;
+            r_ixr_cmd_word    = 0;
+            r_ixr_cmd_fsm     = IXR_CMD_CLEANUP_DATA_SEND;
+            for( size_t i=0 ; i<m_words ; i++ ) r_ixr_cmd_wdata[i] = entry.wdata[i];
 
 #if DEBUG_MEMC_IXR_CMD
 if(m_debug)
-std::cout << "  <MEMC " << name() << " IXR_CMD_CAS>"
-          << " Send a get request to xram / address = " << std::hex
-          << (addr_t)(r_cas_to_ixr_cmd_nline.read()*m_words*4) << std::endl;
-#endif
-        }
-      }
-      break;
-    }
-    //////////////////
-    case IXR_CMD_XRAM:     // send a put from XRAM_RSP FSM
-    {
-      if(p_vci_ixr.cmdack)
-      {
-        if(r_ixr_cmd_cpt.read() == (m_words - 2))
-        {
-          r_ixr_cmd_cpt = 0;
-          r_ixr_cmd_fsm = IXR_CMD_XRAM_IDLE;
-          r_xram_rsp_to_ixr_cmd_req = false;
+std::cout << "  <MEMC " << name() << " IXR_CMD_CLEANUP_TRT> TRT access"
+          << " index = " << std::dec << r_cleanup_to_ixr_cmd_index.read()
+          << " / address = " << std::hex << (entry.nline*(m_words<<2)) << std::endl;
+#endif
+        }
+        break;
+    }
+    ////////////////////////
+    case IXR_CMD_CONFIG_TRT:       // access TRT for a PUT
+    {
+        if ( r_alloc_trt_fsm.read() == ALLOC_TRT_IXR_CMD )
+        {
+            TransactionTabEntry entry = m_trt.read( r_config_to_ixr_cmd_index.read() );
+            r_ixr_cmd_address = entry.nline * (m_words<<2);
+            r_ixr_cmd_trdid   = r_config_to_ixr_cmd_index.read();
+            r_ixr_cmd_get     = false;
+            r_ixr_cmd_word    = 0;
+            r_ixr_cmd_fsm     = IXR_CMD_CONFIG_SEND;
+            for( size_t i=0 ; i<m_words ; i++ ) r_ixr_cmd_wdata[i] = entry.wdata[i];
+
+#if DEBUG_MEMC_IXR_CMD
+if(m_debug)
+std::cout << "  <MEMC " << name() << " IXR_CMD_CONFIG_TRT> TRT access"
+          << " index = " << std::dec << r_config_to_ixr_cmd_index.read()
+          << " / address = " << std::hex << (entry.nline*(m_words<<2)) << std::endl;
+#endif
+        }
+        break;
+    }
+
+    ///////////////////////
+    case IXR_CMD_READ_SEND:      // send a get from READ FSM
+    {
+        if(p_vci_ixr.cmdack)
+        {
+            r_ixr_cmd_fsm         = IXR_CMD_READ_IDLE;
+            r_read_to_ixr_cmd_req = false;
+
+#if DEBUG_MEMC_IXR_CMD
+if(m_debug)
+std::cout << "  <MEMC " << name() << " IXR_CMD_READ_SEND> GET request:" << std::hex
+          << " address = " << r_ixr_cmd_address.read() + (r_ixr_cmd_word.read()<<2) << std::endl;
+#endif
+        }
+        break;
+    }
+    ////////////////////////
+    case IXR_CMD_WRITE_SEND:     // send a put or get from WRITE FSM
+    {
+        if(p_vci_ixr.cmdack)
+        {
+            if(r_write_to_ixr_cmd_put.read())   // PUT
+            {
+                if(r_ixr_cmd_word.read() == (m_words - 2))
+                {
+                    r_ixr_cmd_fsm          = IXR_CMD_WRITE_IDLE;
+                    r_write_to_ixr_cmd_req = false;
+                }
+                else
+                {
+                    r_ixr_cmd_word = r_ixr_cmd_word.read() + 2;
+                }
+
+#if DEBUG_MEMC_IXR_CMD
+if(m_debug)
+std::cout << "  <MEMC " << name() << " IXR_CMD_WRITE_SEND> PUT request:" << std::hex
+          << " address = " << r_ixr_cmd_address.read() + (r_ixr_cmd_word.read()<<2) << std::endl;
+#endif
+            }
+            else                                  // GET
+            {
+                r_ixr_cmd_fsm          = IXR_CMD_WRITE_IDLE;
+                r_write_to_ixr_cmd_req = false;
+
+#if DEBUG_MEMC_IXR_CMD
+if(m_debug)
+std::cout << "  <MEMC " << name() << " IXR_CMD_WRITE_SEND> GET request:" << std::hex
+          << " address = " << r_ixr_cmd_address.read() + (r_ixr_cmd_word.read()<<2) << std::endl;
+#endif
+            }
+        }
+        break;
+    }
+    //////////////////////
+    case IXR_CMD_CAS_SEND:      // send a put or get command from CAS FSM
+    {
+        if(p_vci_ixr.cmdack)
+        {
+            if(r_cas_to_ixr_cmd_put.read()) // PUT
+            {
+                if(r_ixr_cmd_word.read() == (m_words - 2))
+                {
+                    r_ixr_cmd_fsm        = IXR_CMD_CAS_IDLE;
+                    r_cas_to_ixr_cmd_req = false;
+                }
+                else
+                {
+                    r_ixr_cmd_word = r_ixr_cmd_word.read() + 2;
+                }
+
+#if DEBUG_MEMC_IXR_CMD
+if(m_debug)
+std::cout << "  <MEMC " << name() << " IXR_CMD_CAS_SEND> PUT request:" << std::hex
+          << " address = " << r_ixr_cmd_address.read() + (r_ixr_cmd_word.read()<<2) << std::endl;
+#endif
+            }
+            else                            // GET
+            {
+                r_ixr_cmd_fsm        = IXR_CMD_CAS_IDLE;
+                r_cas_to_ixr_cmd_req = false;
+
+#if DEBUG_MEMC_IXR_CMD
+if(m_debug)
+std::cout << "  <MEMC " << name() << " IXR_CMD_CAS_SEND> GET request:" << std::hex
+          << " address = " << r_ixr_cmd_address.read() + (r_ixr_cmd_word.read()<<2) << std::endl;
+#endif
+            }
+        }
+        break;
+    }
+    ///////////////////////
+    case IXR_CMD_XRAM_SEND:     // send a put from XRAM_RSP FSM
+    {
+        if(p_vci_ixr.cmdack.read())
+        {
+            if(r_ixr_cmd_word.read() == (m_words - 2))
+            {
+                r_ixr_cmd_fsm = IXR_CMD_XRAM_IDLE;
+                r_xram_rsp_to_ixr_cmd_req = false;
+            }
+            else
+            {
+                r_ixr_cmd_word = r_ixr_cmd_word.read() + 2;
+            }
+#if DEBUG_MEMC_IXR_CMD
+if(m_debug)
+std::cout << "  <MEMC " << name() << " IXR_CMD_XRAM_SEND> PUT request:" << std::hex
+          << " address = " << r_ixr_cmd_address.read() + (r_ixr_cmd_word.read()<<2) << std::endl;
+#endif
+        }
+        break;
+    }
+
+      ////////////////////////
+    case IXR_CMD_CLEANUP_DATA_SEND:     // send a put command to XRAM
+    {
+      if(p_vci_ixr.cmdack.read())
+      {
+        /*ODCCP*/ //std::cout << "IXR_CMD_CLEANUP_DATA_SEND STATE at cycle : " << std::dec << m_cpt_cycles << std::endl;
+        if(r_ixr_cmd_word.read() == (m_words - 2))
+        {
+          /*ODCCP*/ //std::cout << "IXR_CMD_CLEANUP_DATA_SEND GO TO IXR_CMD_CLEANUP_IDLE" << std::endl;
+          r_ixr_cmd_fsm = IXR_CMD_CLEANUP_IDLE;
+          r_cleanup_to_ixr_cmd_req = false;
+          //r_ixr_cmd_word = 0;
+          //r_xram_rsp_to_ixr_cmd_inval_ncc_pending = false;
         }
         else
         {
-          r_ixr_cmd_cpt = r_ixr_cmd_cpt + 2;
-        }
-
-#if DEBUG_MEMC_IXR_CMD
-if(m_debug)
-std::cout << "  <MEMC " << name() << " IXR_CMD_XRAM>"
-          << " Send a put request to xram / address = " << std::hex
-          << (addr_t)( (r_xram_rsp_to_ixr_cmd_nline.read() * m_words +
-                       r_ixr_cmd_cpt.read()) * 4 ) << std::endl;
-#endif
-      }
-      break;
-    }
-
-      ////////////////////////
-    case IXR_CMD_CLEANUP_DATA:     // send a put command to XRAM
-      /*ODCCP*///std::cout << "IXR_CMD_CLEANUP_DATA" << std::endl;
-      if(p_vci_ixr.cmdack)
-      {
-        if(r_ixr_cmd_cpt.read() == (m_words - 2))
-        {
-          r_ixr_cmd_cpt = 0;
-          r_ixr_cmd_fsm = IXR_CMD_CLEANUP_IDLE;
-          r_xram_rsp_to_ixr_cmd_inval_ncc_pending = false;
-          r_cleanup_to_ixr_cmd_req = false;
-        }
-        else
-        {
-          r_ixr_cmd_cpt = r_ixr_cmd_cpt.read() + 2;
+          r_ixr_cmd_word = r_ixr_cmd_word.read() + 2;
         }
 
@@ -4079,10 +4259,34 @@
         if(m_debug)
         {
-          std::cout << "  <MEMC " << name() << ".IXR_CMD_CLEANUP_DATA> Send a put request to xram" << std::endl;
-        }
-#endif
-      }
-      break;
-
+          std::cout << "  <MEMC " << name() << ".IXR_CMD_CLEANUP_DATA_SEND> Send a put request to xram" << std::endl;
+        }
+#endif
+      }
+      break;
+    }
+
+    /////////////////////////
+    case IXR_CMD_CONFIG_SEND:     // send a put from CONFIG FSM
+    {
+        if(p_vci_ixr.cmdack.read())
+        {
+            if(r_ixr_cmd_word.read() == (m_words - 2))
+            {
+                r_ixr_cmd_fsm = IXR_CMD_CONFIG_IDLE;
+                r_config_to_ixr_cmd_req = false;
+            }
+            else
+            {
+                r_ixr_cmd_word = r_ixr_cmd_word.read() + 2;
+            }
+
+#if DEBUG_MEMC_IXR_CMD
+if(m_debug)
+std::cout << "  <MEMC " << name() << " IXR_CMD_CONFIG_SEND> PUT request:" << std::hex
+          << " address = " << r_ixr_cmd_address.read() + (r_ixr_cmd_word.read()<<2) << std::endl;
+#endif
+        }
+        break;
+    }
   } // end switch r_ixr_cmd_fsm
 
@@ -4091,17 +4295,19 @@
   ////////////////////////////////////////////////////////////////////////////
   // The IXR_RSP FSM receives the response packets from the XRAM,
-  // for both put transaction, and get transaction.
+  // for both PUT transaction, and GET transaction.
   //
-  // - A response to a put request is a single-cell VCI packet.
-  // The Transaction Tab index is contained in the RTRDID field.
+  // - A response to a PUT request is a single-cell VCI packet.
+  // The TRT index is contained in the RTRDID field.
   // The FSM takes the lock protecting the TRT, and the corresponding
-  // entry is erased.
+  // entry is erased. If an acknowledge was required (in case of software SYNC)
+  // the r_config_rsp_lines counter is decremented.  
   //
-  // - A response to a get request is a multi-cell VCI packet.
-  // The Transaction Tab index is contained in the RTRDID field.
+  // - A response to a GET request is a multi-cell VCI packet.
+  // The TRT index is contained in the RTRDID field.
   // The N cells contain the N words of the cache line in the RDATA field.
   // The FSM takes the lock protecting the TRT to store the line in the TRT
   // (taking into account the write requests already stored in the TRT).
-  // When the line is completely written, the corresponding rok signal is set.
+  // When the line is completely written, the r_ixr_rsp_to_xram_rsp_rok[index]  
+  // signal is set to inform the XRAM_RSP FSM.
   ///////////////////////////////////////////////////////////////////////////////
 
@@ -4111,21 +4317,20 @@
     case IXR_RSP_IDLE:  // test transaction type: PUT/GET
     {
-      if(p_vci_ixr.rspval.read())
-      {
-        r_ixr_rsp_cpt   = 0;
-        r_ixr_rsp_trt_index = p_vci_ixr.rtrdid.read();
-        if(p_vci_ixr.reop.read() and !(p_vci_ixr.rerror.read() &0x1))   // PUT transaction
-        {
-          r_ixr_rsp_fsm = IXR_RSP_ACK;
-
-#if DEBUG_MEMC_IXR_RSP
-if(m_debug)
-std::cout << "  <MEMC " << name()
-          << " IXR_RSP_IDLE> Response from XRAM to a put transaction" << std::endl;
-#endif
-        }
-        else                                                         // GET transaction
-        {
-          r_ixr_rsp_fsm = IXR_RSP_TRT_READ;
+          if(p_vci_ixr.rspval.read())
+          {
+              r_ixr_rsp_cpt       = 0;
+              r_ixr_rsp_trt_index = p_vci_ixr.rtrdid.read();
+
+              assert( ((p_vci_ixr.rerror.read() & 0x1) == 0) and
+              "MEMC ERROR in IXR_RSP state: XRAM response error !");
+
+              if(p_vci_ixr.reop.read())   // PUT
+              {
+                  r_ixr_rsp_fsm = IXR_RSP_TRT_ERASE;
+              }
+
+              else                       // GET transaction
+              {
+                  r_ixr_rsp_fsm = IXR_RSP_TRT_READ;
 
 #if DEBUG_MEMC_IXR_RSP
@@ -4134,27 +4339,27 @@
           << " IXR_RSP_IDLE> Response from XRAM to a get transaction" << std::endl;
 #endif
-        }
-      }
-      break;
-    }
-    /////////////////
-    case IXR_RSP_ACK:        // Aknowledge the VCI response for a PUT
-    {
-      if(p_vci_ixr.rspval.read()) r_ixr_rsp_fsm = IXR_RSP_TRT_ERASE;
-
-#if DEBUG_MEMC_IXR_RSP
-if(m_debug)
-std::cout << "  <MEMC " << name() << " IXR_RSP_ACK>" << std::endl;
-#endif
+              }     
+          } 
       break;
     }
     ////////////////////////
+    case IXR_RSP_ACK:     // Acknowledge PUT transaction
+    {
+        r_ixr_rsp_fsm = IXR_RSP_IDLE;
+        break;
+    }
+
+   ////////////////////////
     case IXR_RSP_TRT_ERASE:   // erase the entry in the TRT
-    {
-      if(r_alloc_trt_fsm.read() == ALLOC_TRT_IXR_RSP)
-      {
-        m_trt.erase(r_ixr_rsp_trt_index.read());
-        r_ixr_rsp_fsm = IXR_RSP_IDLE;
-
+                              // decrease the line counter if config request
+    {
+        if(r_alloc_trt_fsm.read() == ALLOC_TRT_IXR_RSP)
+        {
+            size_t  index = r_ixr_rsp_trt_index.read(); 
+            if (m_trt.is_config(index) ) r_config_rsp_lines = r_config_rsp_lines.read() - 1;
+            m_trt.erase(index);
+            r_ixr_rsp_fsm = IXR_RSP_IDLE;
+
+//            std::cout << "remove a valid slot in trt index = " << r_ixr_rsp_trt_index.read()<< std::endl;
 #if DEBUG_MEMC_IXR_RSP
 if(m_debug)
@@ -4162,36 +4367,32 @@
           << r_ixr_rsp_trt_index.read() << std::endl;
 #endif
-      m_cpt_ixr_fsm_n_trt_lock++;
-      }
-
-      m_cpt_ixr_fsm_trt_lock++;
-
-      break;
+        }
+        break;
     }
     //////////////////////
     case IXR_RSP_TRT_READ:    // write a 64 bits data in the TRT
     {
-      if((r_alloc_trt_fsm.read() == ALLOC_TRT_IXR_RSP) and  p_vci_ixr.rspval)
-      {
-        size_t      index    = r_ixr_rsp_trt_index.read();
-        bool        eop      = p_vci_ixr.reop.read();
-        wide_data_t data     = p_vci_ixr.rdata.read();
-        bool        error    = ((p_vci_ixr.rerror.read() & 0x1) == 1);
-
-        assert(((eop == (r_ixr_rsp_cpt.read() == (m_words-2))) or p_vci_ixr.rerror.read())
-               and "Error in VCI_MEM_CACHE : invalid length for a response from XRAM");
-
-        m_trt.write_rsp( index,
-                         r_ixr_rsp_cpt.read(),
-                         data,
-                         error);
-
-        r_ixr_rsp_cpt = r_ixr_rsp_cpt.read() + 2;
-
-        if(eop)
-        {
-          r_ixr_rsp_to_xram_rsp_rok[r_ixr_rsp_trt_index.read()]=true;
-          r_ixr_rsp_fsm = IXR_RSP_IDLE;
-        }
+          if((r_alloc_trt_fsm.read() == ALLOC_TRT_IXR_RSP) and  p_vci_ixr.rspval)
+          {
+              size_t      index    = r_ixr_rsp_trt_index.read();
+              size_t      word     = r_ixr_rsp_cpt.read();
+              bool        eop      = p_vci_ixr.reop.read();
+              wide_data_t data     = p_vci_ixr.rdata.read();
+              bool        error    = ((p_vci_ixr.rerror.read() & 0x1) == 1);
+
+              assert(((eop == (word == (m_words-2))) or error) and
+              "MEMC ERROR in IXR_RSP_TRT_READ state : invalid response from XRAM");
+ 
+              m_trt.write_rsp( index,
+                               word,
+                               data );
+
+              r_ixr_rsp_cpt = word + 2;
+
+              if(eop)
+              {
+                r_ixr_rsp_to_xram_rsp_rok[r_ixr_rsp_trt_index.read()]=true;
+                r_ixr_rsp_fsm = IXR_RSP_IDLE;
+              }
 
 #if DEBUG_MEMC_IXR_RSP
@@ -4199,5 +4400,5 @@
 std::cout << "  <MEMC " << name() << " IXR_RSP_TRT_READ> Writing a word in TRT : "
           << " index = " << std::dec << index
-          << " / word = " << r_ixr_rsp_cpt.read()
+          << " / word = " << word
           << " / data = " << std::hex << data << std::endl;
 #endif
@@ -4212,15 +4413,15 @@
   //                XRAM_RSP FSM
   ////////////////////////////////////////////////////////////////////////////
-  // The XRAM_RSP FSM handles the incoming cache lines from the XRAM.
+  // The XRAM_RSP FSM handles the incoming cache lines after an XRAM GET.
   // The cache line has been written in the TRT by the IXR_CMD_FSM.
   // As the IXR_RSP FSM and the XRAM_RSP FSM are running in parallel,
-  // there is as many flip-flops r_ixr_rsp_to_xram_rsp_rok[i]
-  // as the number of entries in the TRT, that are handled with
-  // a round-robin priority...
+  // there is as many flip-flops r_ixr_rsp_to_xram_rsp_rok[i] as the number 
+  // of entries in the TRT, that are handled with a round-robin priority...
   //
-  // When a response is available, the corresponding TRT entry
-  // is copied in a local buffer to be written in the cache.
-  // The FSM takes the lock protecting the TRT, and the lock protecting the DIR.
-  // It selects a cache slot and writes the line in the cache.
+  // The FSM takes the lock protecting TRT, and the lock protecting DIR.
+  // The selected TRT entry is copied in the local buffer r_xram_rsp_trt_buf.
+  // It selects a cache slot and save the victim line in another local buffer
+  // r_xram_rsp_victim_***.
+  // It writes the line extracted from TRT in the cache.
   // If it was a read MISS, the XRAM_RSP FSM send a request to the TGT_RSP
   // FSM to return the cache line to the registered processor.
@@ -4237,14 +4438,14 @@
     case XRAM_RSP_IDLE: // scan the XRAM responses / select a TRT index (round robin)
     {
-      size_t ptr   = r_xram_rsp_trt_index.read();
-      size_t lines = m_trt_lines;
-      for(size_t i=0 ; i<lines ; i++)
-      {
-        size_t index = (i+ptr+1) %lines;
-        if(r_ixr_rsp_to_xram_rsp_rok[index])
-        {
-          r_xram_rsp_trt_index             = index;
-          r_ixr_rsp_to_xram_rsp_rok[index] = false;
-          r_xram_rsp_fsm                   = XRAM_RSP_DIR_LOCK;
+        size_t old   = r_xram_rsp_trt_index.read();
+        size_t lines = m_trt_lines;
+        for(size_t i=0 ; i<lines ; i++)
+        {
+            size_t index = (i+old+1) %lines;
+            if(r_ixr_rsp_to_xram_rsp_rok[index])
+            {
+                r_xram_rsp_trt_index             = index;
+                r_ixr_rsp_to_xram_rsp_rok[index] = false;
+                r_xram_rsp_fsm                   = XRAM_RSP_DIR_LOCK;
 
 #if DEBUG_MEMC_XRAM_RSP
@@ -4254,7 +4455,7 @@
           << " index = " << std::dec << index << std::endl;
 #endif
-          break;
-        }
-      }
+                break;
+            }
+        } 
       break;
     }
@@ -4269,5 +4470,4 @@
         size_t  index = r_xram_rsp_trt_index.read();
         r_xram_rsp_trt_buf.copy( m_trt.read(index) );
-
         r_xram_rsp_fsm = XRAM_RSP_TRT_COPY;
 
@@ -4288,7 +4488,10 @@
                             // and copy it in a local buffer
     {
-      if ( (r_alloc_trt_fsm.read() == ALLOC_TRT_XRAM_RSP) and
-           (r_alloc_dir_fsm.read() == ALLOC_DIR_XRAM_RSP) )
-      {
+        assert( (r_alloc_dir_fsm.read() == ALLOC_DIR_XRAM_RSP) and
+        "MEMC ERROR in XRAM_RSP_TRT_COPY state: Bad DIR allocation");
+
+        assert( (r_alloc_trt_fsm.read() == ALLOC_TRT_XRAM_RSP) and
+        "MEMC ERROR in XRAM_RSP_TRT_COPY state: Bad TRT allocation");
+
         // selects & extracts a victim line from cache
         size_t way = 0;
